import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MpOfficialMenu, MpOfficialMenuParam } from './model';


/**
 * 分页查询小程序端菜单
 */
export async function pageMpOfficialMenu(params: MpOfficialMenuParam) {
  const res = await request.get<ApiResult<PageResult<MpOfficialMenu>>>(
    '/cms/mp-official-menu/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询小程序端菜单列表
 */
export async function listMpOfficialMenu(params?: MpOfficialMenuParam) {
  const res = await request.get<ApiResult<MpOfficialMenu[]>>(
    '/cms/mp-official-menu',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加小程序端菜单
 */
export async function addMpOfficialMenu(data: MpOfficialMenu) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/mp-official-menu',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改小程序端菜单
 */
export async function updateMpOfficialMenu(data: MpOfficialMenu) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/mp-official-menu',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除小程序端菜单
 */
export async function removeMpOfficialMenu(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/mp-official-menu/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除小程序端菜单
 */
export async function removeBatchMpOfficialMenu(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/mp-official-menu/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询小程序端菜单
 */
export async function getMpOfficialMenu(id: number) {
  const res = await request.get<ApiResult<MpOfficialMenu>>(
    '/cms/mp-official-menu/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
